;===========================================================================================
; directxproc.asm   AsmGges France  http://www.chez.com/asmgges/
;===========================================================================================

;===========================================================================================
; Cration d'une surface
;-------------------------------------------------------------------------------------------
; @AdrSurface = adresse de la variable qui va contenir l'adresse de la surface cre
; @LSurface   = largeur de la surface en pixels
; @HSurface   = hauteur de la surface en pixels
;===========================================================================================
CreateSurf frame @AdrSurface, @LSurface, @HSurface

    invoke ZeroMemory,addr ddsd,sizeof DDSURFACEDESC
    mov D[ddsd.dwSize],sizeof DDSURFACEDESC
    mov D[ddsd.dwFlags],DDSD_CAPS+DDSD_WIDTH+DDSD_HEIGHT
    mov D[ddsd.ddsCaps.dwCaps],DDSCAPS_OFFSCREENPLAIN
    mov eax,[@LSurface]
    mov [ddsd.dwWidth],eax
    mov eax,[@HSurface]
    mov [ddsd.dwHeight],eax
    dd_createsurface([DDraw],addr ddsd,[@AdrSurface],0)

    ret
endf
;===========================================================================================
; Remplir une surface avec une couleur
;-------------------------------------------------------------------------------------------
; @Surface = [Nom] Surface  remplir
; @Color   = couleur de remplissage format RGB 000000h
;===========================================================================================
FillSurface frame @Surface, @Color

    invoke ZeroMemory,addr ddbltfx,sizeof DDBLTFX
    mov D[ddbltfx.dwSize],sizeof DDBLTFX
    mov eax,[@Color]
    mov [ddbltfx.dwFillColor],eax
    dds_blt([@Surface],0,0,0,DDBLT_COLORFILL+DDBLT_WAIT,addr ddbltfx)

    ret
endf
;===========================================================================================
; Charger un fichier bmp
;------------------------------------------------------------------------------------------- 
; @Filename = adresse de la chaine chemin du fichier
; @Surface  = [nom] de la surface de destination
;===========================================================================================
LoadBmp frame @Filename, @Surface

    invoke LoadImageA,0,[@Filename],IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION+LR_LOADFROMFILE
    or eax,eax
    jnz >
        mov eax,1
        ret
    :
    mov [hBitmap],eax

    invoke GetObjectA,[hBitmap],24,addr bitmap

    invoke CreateCompatibleDC,0
    mov [hdcImage],eax

    invoke SelectObject,[hdcImage],[hBitmap]
    mov [hbmOld],eax

    dds_getdc([@Surface],addr hdc)
    or eax,eax
    jnz >
        invoke BitBlt,[hdc],0,0,[bitmap.bmWidth],[bitmap.bmHeight],[hdcImage],0,0,SRCCOPY
        dds_releasedc([@Surface],[hdc])
    :
    invoke SelectObject,[hdcImage],[hbmOld]
    invoke DeleteObject,[hBitmap]
    invoke DeleteDC,[hdcImage]

    dds_setcolorkey([@Surface],DDCKEY_SRCBLT,addr ddcolorkey)
    or eax,eax
    jz  >
        mov eax,1
        ret 
    :

    mov eax,0

    ret
endf
;===========================================================================================
; Flip surface Back => surface Primary (Window Mode)
;===========================================================================================
FlipBackWinMode:
    invoke GetWindowRect,[hWin],addr rect2

    mov D[rect1.left],0
    mov D[rect1.top],0
    mov D[rect1.right],WSCREEN
    mov D[rect1.bottom],HSCREEN

    mov eax,[rect2.left]
    add eax,WSCREEN
    mov [rect2.right],eax

    mov eax,[rect2.top]
    add eax,[HBarTitle]
    mov [rect2.top],eax

    add eax,HSCREEN
    mov [rect2.bottom],eax
    dds_blt([Primary],addr rect2,[Back],addr rect1,DDBLT_WAIT,0)

    ret
;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================
