;===========================================================================================
; loadbmp.asm  GoAsm assembler
; Charger un fichier bmp en mode fentre ou en mode plein cran              
; Programm par AsmGges France                      http://www.chez.com/asmgges/index.htm
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\loadbmp.rc
; ..\..\bin\GoAsm loadbmp.asm
; ..\..\bin\GoLink loadbmp.obj res\loadbmp.res user32.dll kernel32.dll gdi32.dll winmm.dll 
;                                                                                ddraw.dll
;===========================================================================================

  #include "ggesdx\win32a.inc"
  #include "ggesdx\gddraw.inc"

  ID_FRANCE = 17

  WSCREEN   = 640
  HSCREEN   = 480

;===========================================================================================
.code

start:
    invoke  MessageBox,HWND_DESKTOP,addr MsgMode,addr BoxCaption,MB_YESNO
    cmp eax,IDYES
    jne >
        mov D[FullMode],1
    :
    invoke GetModuleHandle,NULL
    mov [wc.hInstance],eax

    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    invoke LoadCursor,NULL,IDC_ARROW
    mov [wc.hCursor],eax

    invoke RegisterClass,addr wc

    invoke GetSystemMetrics,SM_CXSCREEN
    mov [rectuser.right],eax           ;sauve le clipping actuel en x dans rectuser (WinMode)
    sub eax,WSCREEN
    shr eax,1
    mov [rect2.left],eax

    invoke GetSystemMetrics,SM_CYSCREEN
    mov [rectuser.bottom],eax          ;sauve le clipping actuel en y dans rectuser (WinMode)
    sub eax,HSCREEN
    shr eax,1
    mov [rect2.top],eax

    cmp D[FullMode],1
    jne >
        invoke CreateWindowEx,0,addr ClassName,addr WinCaption,WS_POPUP+WS_VISIBLE,\
                              0,0,0,0,0,0,[wc.hInstance],0
        mov [hWin],eax
        jmp >>L1
    :
        mov D[rect1.left],0
        mov D[rect1.top],0
        mov D[rect1.right],WSCREEN
        mov D[rect1.bottom],HSCREEN
        invoke AdjustWindowRectEx,addr rect1,04CA0000h,0,NULL

        mov eax,[rect1.bottom]
        sub eax,[rect1.top]
        sub eax,HSCREEN
        sub eax,3            ;moins bord infrieur menu/fentre active
        mov [HBarTitle],eax  ;hauteur du bandeau titre

        invoke GetSystemMetrics,SM_CYSCREEN
        mov [rectuser.bottom],eax
        sub eax,HSCREEN
        sub eax,[HBarTitle]
        shr eax,TRUE
        mov [rect2.top],eax

        mov eax,HSCREEN
        add eax,[HBarTitle]

        ;----------------------------------
        ; Cration fentre barre suprieure
        ;----------------------------------
        invoke CreateWindowEx,NULL,addr ClassName,addr WinCaption,04CA0000h,[rect2.left],\
                                     [rect2.top],WSCREEN,eax,NULL,0,[wc.hInstance],NULL
        mov [hWin],eax

    L1:
    invoke ShowWindow,[hWin],SW_SHOWDEFAULT
    invoke UpdateWindow,[hWin]

    ;-----------------------------
    ; Initialisation de DirectDraw
    ;-----------------------------
    invoke DirectDrawCreate,0,addr DDraw,0
    or eax,eax
    jnz >DdrawError

    cmp D[FullMode],1
    jne >>
        ;--------------------
        ; Demande plein cran
        ;--------------------
        dd_setcooperativelevel([DDraw],[hWin],DDSCL_EXCLUSIVE+DDSCL_FULLSCREEN)
        or  eax,eax
        jnz >DdrawError

        ;---------------------------------
        ; Passage en 640x480 pixels 16bits
        ;---------------------------------
        dd_setdisplaymode([DDraw],WSCREEN,HSCREEN,16)
        or eax,eax
        jnz >DdrawError
 
        ;----------------------------------------------------
        ; Cration d'une surface primaire avec un back-buffer
        ;----------------------------------------------------
        invoke ZeroMemory,addr ddsd,sizeof DDSURFACEDESC
        mov D[ddsd.dwSize],sizeof DDSURFACEDESC
        mov D[ddsd.dwFlags],DDSD_CAPS + DDSD_BACKBUFFERCOUNT
        mov D[ddsd.ddsCaps.dwCaps],DDSCAPS_PRIMARYSURFACE+DDSCAPS_FLIP+DDSCAPS_COMPLEX
        mov D[ddsd.dwBackBufferCount],1
        dd_createsurface([DDraw],addr ddsd,addr Primary,0)
        or eax,eax
        jnz >DdrawError

        invoke ZeroMemory,addr ddscaps,sizeof DDSCAPS
        mov D[ddscaps.dwCaps],DDSCAPS_BACKBUFFER
        dds_getattachedsurface([Primary],addr ddscaps,addr Back)
        or eax,eax
        jnz >DdrawError
        jmp >>endinitdd
    :
        ;---------
        ; Win Mode
        ;---------
        dd_setcooperativelevel([DDraw],[hWin],DDSCL_NORMAL)
        or eax,eax
        jnz >DdrawError

        ;--------------------------------
        ; Cration de la surface primaire
        ;--------------------------------
        invoke ZeroMemory,addr ddsd,sizeof DDSURFACEDESC
        mov D[ddsd.dwSize],sizeof DDSURFACEDESC
        mov D[ddsd.dwFlags],DDSD_CAPS
        mov D[ddsd.ddsCaps.dwCaps],DDSCAPS_PRIMARYSURFACE
        dd_createsurface([DDraw],addr ddsd,addr Primary,0)
        or eax,eax
        jnz >DdrawError

        ;-----------------------------------
        ; Cration de la surface Back-buffer
        ;-----------------------------------
        invoke ZeroMemory,addr ddsd,sizeof DDSURFACEDESC
        mov D[ddsd.dwSize],sizeof DDSURFACEDESC
        mov D[ddsd.dwFlags],DDSD_CAPS+DDSD_WIDTH+DDSD_HEIGHT
        mov D[ddsd.ddsCaps.dwCaps],DDSCAPS_OFFSCREENPLAIN
        mov D[ddsd.dwWidth],WSCREEN
        mov eax,HSCREEN
        add eax,[HBarTitle]
        mov [ddsd.dwHeight],eax
        dd_createsurface([DDraw],addr ddsd,addr Back,0)
        or eax,eax
        jnz >DdrawError

        ;----------------------
        ; Cration d'un clipper
        ;----------------------
        dd_createclipper([DDraw],0,addr lpClipper,0)
        or eax,eax
        jnz >DdrawError

        ddc_sethwnd([lpClipper],0,[hWin])
        or eax,eax
        jnz >DdrawError

        dds_setclipper([Primary],[lpClipper])
        or eax,eax
        jnz >DdrawError
    
    endinitdd:

    ;---------------------
    ; Create: Fond surface
    ;---------------------
    invoke ZeroMemory,addr ddsd,sizeof DDSURFACEDESC
    mov D[ddsd.dwSize],sizeof DDSURFACEDESC
    mov D[ddsd.dwFlags],DDSD_CAPS+DDSD_HEIGHT+DDSD_WIDTH
    mov D[ddsd.ddsCaps],DDSCAPS_OFFSCREENPLAIN
    mov D[ddsd.dwWidth],WSCREEN
    mov D[ddsd.dwHeight],HSCREEN
    dd_createsurface([DDraw],addr ddsd,addr Fond,0)
    or  eax,eax
    jnz >DdrawError

    ;---------
    ; Load bmp
    ;---------
    invoke LoadBmp,addr BmpFile,[Fond]
    or eax,eax
    jnz >>DataError

    invoke timeBeginPeriod,1
    mov D[FpsMax],60

    jmp >MenuLoop

Debut:


;===========================================================================================

GameLoop:

    ;----------------------
    ; Refresh: Back surface
    ;----------------------
    mov D[rect1.left],0
    mov D[rect1.top],0
    mov D[rect1.right],WSCREEN
    mov D[rect1.bottom],HSCREEN
    dds_bltfast([Back],0,0,[Fond],addr rect1,DDBLTFAST_NOCOLORKEY+DDBLTFAST_WAIT)
 

    jmp >MessageLoop

;===========================================================================================

MenuLoop:



;===========================================================================================

MessageLoop:

    invoke PeekMessage,addr msg,0,0,0,PM_NOREMOVE
    or eax,eax
    jz  >
        invoke GetMessage,addr msg,0,0,0
        or eax,eax
        jz >ExitGame
        invoke TranslateMessage,addr msg
        invoke DispatchMessage,addr msg
        jmp <MessageLoop
    :
    cmp B[bActive],0
    jne >
        invoke WaitMessage
        jmp <MessageLoop
    :
        dds_islost([Primary])
        or eax,eax
        je  >.L1
        cmp eax,DDERR_SURFACELOST
        jne >
            dds_restore([Primary])
            jmp >.L1
        :
            jmp >ExitGame
        
    .L1:
    ;-------------------------------------------------
    ; Rgule la vitesse de rafraichissement de l'cran
    ;-------------------------------------------------
    invoke FpsLimiter,[FpsMax]

    ;-----
    ; Flip
    ;-----
    cmp D[FullMode],1
    jne >
        dds_flip([Primary],0,DDFLIP_WAIT)
        jmp >.screen
    :
        call FlipBackWinMode

    .screen:
    ;-----------------------
    ; Ecran de dessin et jeu
    ;-----------------------
    jmp GameLoop

;===========================================================================================

DdrawError:
    mov eax,addr MsgDdError
    jmp >Error

DataError:
    mov eax,addr MsgDataError

Error:
    invoke MessageBox,[hWin],eax,addr WinCaption,0
    invoke DestroyWindow,[hWin]
    invoke PostQuitMessage,1
    jmp <MessageLoop

ExitGame:
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
;===========================================================================================

WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.wmactivate
        call LibereSurf
        jmp >>.exit

    .wmactivate:
    cmp D[@uMsg],WM_ACTIVATE
    jne >.wmkeydown
        mov eax,[@wParam]
        mov B[bActive],al
        jmp >>.exit

    .wmkeydown:
    cmp D[@uMsg],WM_KEYDOWN
    jne >.defwindowproc
        cmp D[@wParam],VK_ESCAPE
        jne >>.exit
            ; Demande la fin de l'application
            ; -------------------------------
            invoke SendMessage,[@hWnd],WM_CLOSE,0,0
            jmp >.exit 

    .defwindowproc:
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:

    mov eax,0
    ret
endf

;===========================================================================================
; Libre les surfaces
;===========================================================================================
LibereSurf:

    invoke timeEndPeriod,1

    cmp D[DDraw],0
    je  >>.exit
        cmp D[Fond],0
        je  >
            dds_release([Fond])
            mov D[Fond],0
        :
        cmp D[lpClipper],0
        je  >
            dds_release([lpClipper])
            mov D[lpClipper],0
        :
        cmp D[Back],0
        je  >
            dds_release([Back])
            mov D[Back],0
        :
        cmp D[Primary],0
        je  >
            dds_release([Primary])
            mov D[Primary],0
        :
        dds_release([DDraw])
        mov D[DDraw],0

    .exit:
    invoke PostQuitMessage,0

    ret
;===========================================================================================

  #include "ggesdx\directxproc.asm"
  #include "ggesdx\generalproc.asm"

;===========================================================================================
.data

 ClassName     db 'AsmGges',0
 WinCaption    db ' AsmGges Win32Asm GoAsm DirectX',0
 BoxCaption    db ' AsmGges Win32Asm',0
 MsgMode       db '            Full screen mode ?',0
 MsgDdError    db 'Direct Draw: failed',0
 MsgDataError  db 'Opening data file: failed',0
 BmpFile       db 'res\goasm.bmp',0
 align 4

 hdc           dd 0
 hWin          dd 0
 hBitmap       dd 0  
 hdcImage      dd 0  
 hbmOld        dd 0  
 FullMode      dd 0
 HBarTitle     dd 0
 bActive       db 0
 align 4

 FpsMax        dd 0
 NextTimeEdx   dd 0
 NextTimeEax   dd 0
 PerfFreq      dq 0
 PerfCounter   dq 0

 DDraw         dd 0 
 lpClipper     dd 0 
 Fond          dd 0

 Primary       dd 0   
 Back          dd 0   

 wc            WNDCLASS      < 0,addr WindowProc,0,0,0,0,0,0,0,addr ClassName >
 msg           MSG           <>

 ddsd          DDSURFACEDESC <>
 ddscaps       DDSCAPS       <>
 ddbltfx       DDBLTFX       <>
 ddpixelformat DDPIXELFORMAT <>
 bitmap        BITMAP        <>
 ddcolorkey    DDCOLORKEY    <>

 rect1         RECT <>
 rect2         RECT <>
 rectuser      RECT <>

;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================